﻿Type=StaticCode
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public d_freqs() As Double
	Public s_pitchnames() As String
End Sub

Sub Init(iA As Int)
	s_pitchnames = Array As String("A", "A#", "B", "C", "C#", "D", "D#", "E", "F", "F#", "G", "G#")
	d_freqs = Array As Double(iA * 1.0, iA * 1.059463, iA * 1.122462, iA * 1.189207, iA * 1.259921, iA * 1.33484, iA * 1.414214, iA * 1.498307, iA * 1.587401, iA * 1.681793, iA * 1.781797, iA * 1.887749)
End Sub

Sub EqualOktave(freq As Double) As Double
	Dim dA As Double = d_freqs(0), dFreq As Double = freq
	Dim iTolleranz As Int = 12 'damit man auch etwas tiefer als Kammerton spielen kann!
	Do While dFreq < (dA - iTolleranz)
		dFreq = dFreq * 2
	Loop
	Do While dFreq >= (2 * dA)
		dFreq = dFreq / 2
	Loop
	Return dFreq
End Sub

Sub GetPichNr(freq As Double) As Int
	Dim iPitchNr As Int = 0, dFreq As Double = EqualOktave(freq)
		For i = 0 To d_freqs.Length - 1
			If Abs(dFreq - d_freqs(i)) < Abs(dFreq - d_freqs(iPitchNr)) Then iPitchNr = i
		Next
	Return iPitchNr
End Sub

Sub GetPitchFreq(pitchNr As Int) As Double
	Return d_freqs(pitchNr)
End Sub

Sub GetPichname(pitchNr As Int) As String
	Return s_pitchnames(pitchNr)
End Sub

Sub GetPichname2(freq As Double) As String
	Dim iPitchNr As Int = GetPichNr(freq)
	Return GetPichname(iPitchNr)
End Sub


Sub GetFreqDiffInCent(Freq1 As Double, Freq2 As Double) As String
    Dim iCent As Int = Round(1200 * 3.322038403 * Logarithm(Freq2 / Freq1, 10))
	If iCent > 0 Then
		Return "+" & iCent & " cent"
	else if iCent < 0 Then
		Return iCent & " cent"
	End If
	Return ""
End Sub

Sub FillAfreqVars(spn As Spinner)
	spn.Clear
	spn.Add("439")
	spn.Add("440")
	spn.Add("441")
	spn.Add("442")
	spn.Add("443")
	spn.Add("444")
	spn.SelectedIndex = 2
End Sub